///////////////////////////////////////////////////
//
// 
    wxMenu * Fonctions_menu ; 
//
// d'aprs le script original peertv.pl
//
////Original script written by Adrien Contesse
/// # email: adrien.contesse@peertv.fr
//

#ifndef _frame_h
#define _frame_h

#define ID_LISTICO 10000
#define ID_LISTCHAINES 10001
#define ID_LISTGENRE 10002


char t_langue[][28]={"AAA",
                "FRA",
                "ENG",
                "BUL",
                "DEU",
                "ARA",
		"CHI",
                "DAN",
                "ESP",
		"GRE",
		"HON",
                "ITA",
                "IRA",
                "IND",
		"JAP",
                "KOR",
                "NED",
                "NOR",
                "POL",
                "POR",
                "ROM",
                "RUS",
                "SWE",
                "TCH",
                "TUR",
                "VIE",
                "OTH",
		"UNK"};

char  t_genre[][18]={"AAA","ANI","CIN","DOC","MIX","INF","GAM","LOC","MUS","RAD","RAO","REL","SER","SHO","SPO","TAL","VID","UNK"};
enum
{
    wxH_FILE = 1,
    wxH_FICHIERSOUVRIR,
    wxH_FICHIERSQUITTER,
    wxH_OUTILSFAVORIS,
    wxH_OUTILSPR___4F___4RENCES,
    wxH_OUTILSEPG,
    wxH_OUTILSENREGISTREMENTS,
    wxH_MISELISTES,
    wxH_HELPCONTENTS,
    wxH_HELPINDEX,
    wxH_HELPABOUT,
    wxH_FONCTIONSAJOUTER_AUX_FAVORIS,
    wxH_OUVRIR_AVEC,
    wxH_FONCTIONSENREGISTRER,
    wxH_FONCTIONSENREGISTRER_STOP,
    wxH_FONCTIONSENLEVER,
    wxH_FONCTIONSALLER_SUR_LE_SITE_DE_LA_CHAINE,
    wxH_FONCTIONSSIGNALER_CETTE_CHA__NE_COMME_D___4FAILLANTE_,
    wxH_QUIT,
LIST_CTRL                   = 1000
};
const int ID_LANGUE = 10000;
const int ID_GENRE = 10001;
const int ID_BUTTON = 10002;
const int ID_TYPE = 10101;
wxSizer *Filtres( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );
class MyApp: public wxApp
{
public:
    virtual bool OnInit();
};




class MyListCtrl: public wxListCtrl
{
public:
    MyListCtrl(wxWindow *parent,
               const wxWindowID id,

               const wxPoint& pos,
               const wxSize& size,
               long style)
        : wxListCtrl(parent, id, pos, size, style),
          m_attr(*wxBLUE, *wxCYAN, wxNullFont)
//          m_attr(*wxBLUE, *wxLIGHT_GREY, wxNullFont)
        {
		RecTimer.SetOwner(this);
		indice_focused=-1;
        }
void InsertItemInReportView(int i);
void OnActivated(wxListEvent& event);
void OnSelect(wxListEvent& event);
void OnDeSelect(wxListEvent& event);
void OnDrag(wxListEvent& event);
void OnRightUp (wxListEvent & event); 
void OnRecTimer(wxTimerEvent& event);
//            private:
wxTimer RecTimer;
wxProcess *pEnr;
long num_rec,RecTime,longTime;
long indice,indice_focused;
void OnAjouterFavoris (wxCommandEvent & event);
void OnEnregistrer (wxCommandEvent & event);
void OnStopEnregistrer (wxCommandEvent & event);
void Enregistrer ();
void Play (int ind);
void OnStop();
void OnOuvrirAvec(wxCommandEvent & event);
    wxLog *m_logOld;
    void SetColumnImage(int col, int image);

//    void LogEvent(const wxListEvent& event, const wxChar *eventName);
  //  void LogColEvent(const wxListEvent& event, const wxChar *eventName);

//    virtual wxString OnGetItemText(long item, long column) const;
  //  virtual int OnGetItemColumnImage(long item, long column) const;
   // virtual wxListItemAttr *OnGetItemAttr(long item) const;

    wxListItemAttr m_attr;

    DECLARE_NO_COPY_CLASS(MyListCtrl)
    //void OnFonctionsAjouter_aux_favoris (wxCommandEvent & event);
    //void OnFonctionsEnregistrer (wxCommandEvent & event);
    //void OnFonctionsAller_sur_le_site_de_la_chaine (wxCommandEvent & event);
   // void OnFonctionsSignaler_cette_cha__ ne_comme_d___4faillante_ (wxCommandEvent & event);
    DECLARE_EVENT_TABLE()
 };

class RecCtrl: public wxListCtrl
{
public:
    RecCtrl(wxWindow *parent,
               const wxWindowID id,

               const wxPoint& pos,
               const wxSize& size,
               long style)
        : wxListCtrl(parent, id, pos, size, style),
          m_attr(*wxBLUE, *wxCYAN, wxNullFont)
//          m_attr(*wxBLUE, *wxLIGHT_GREY, wxNullFont)
        {
        }
void OnActivated(wxListEvent& event);
void OnStopEnregistrer (wxCommandEvent & event);
void OnDelRec(wxCommandEvent& event);
void OnDrag(wxListEvent& event);
void OnRightUp (wxListEvent & event); 
void InitWithReportItems(); 
            private:
long indice;
void OnOuvrirAvec(wxCommandEvent & event);
    wxLog *m_logOld;


    wxListItemAttr m_attr;

    DECLARE_NO_COPY_CLASS(RecCtrl)
    DECLARE_EVENT_TABLE()
 };



///////////////////////////////
//
// les valeurs des prfrences
//
//
class Preferences 
{
public:
	Preferences()
		
	{
	 mplayer=wxT("mplayer");
	 lecteur1=wxT("mplayer");
	 lecteur2=wxT("vlc");
	 peercast=1;
	 peercast_exe=wxT("peercast");
	 vlc_exe=wxT("vlc");
	 freeboxtv=0;
	 startlist=wxT("Toutes");
	 mp_ontop=1;
	 vlc_ontop=1;
	 skin_name=wxT("skin_name");
	 vlc_aspect=wxT("4:3");
	 mp_framedrop=1;
	 output=wxT("x11");
	 mp_width=wxT("320");
	 mp_height=wxT("240");
	 vlc_width=wxT("320");
	 vlc_height=wxT("240");
	 rec_dir="";
	 cap_dir="";
	 mychannel_name=wxT("Tout");
	 mychannel_genre=wxT("Toutes");
	 mychannel_bitrate=wxT("128");
	 mp_cache=wxT("512");
	 timeshift=wxT("0");
	 tv9tel=0;
	}
	Preferences(Preferences * p0)
	{
	 mplayer=p0->mplayer;
	 lecteur1=p0->lecteur1;
	 lecteur2=p0->lecteur2;
	 peercast=p0->peercast;
	 peercast_exe=p0->peercast_exe;
	vlc_exe=p0->vlc_exe;
	 freeboxtv=p0->freeboxtv;
	 startlist=p0->startlist;
	 mp_ontop=p0->mp_ontop;
	vlc_ontop=p0->vlc_ontop;
	 skin_name=p0->skin_name;
	vlc_aspect=p0->vlc_aspect;
	 mp_framedrop=p0->mp_framedrop;
	 output=p0->output;
	 mp_width=p0->mp_width;
	 mp_height=p0->mp_height;
	 vlc_width=p0->vlc_width;
	 vlc_height=p0->vlc_height;
	 rec_dir=p0->rec_dir;
	 cap_dir=p0->cap_dir;
	 mychannel_name=p0->mychannel_name;
	 mychannel_genre=p0->mychannel_genre;
	 mychannel_bitrate=p0->mychannel_bitrate;
	 mp_cache=p0->mp_cache;
	 timeshift=p0->timeshift;
	 tv9tel=p0->tv9tel;
	}
void appliquer(Preferences*p0)
	{
	mplayer=p0->mplayer;
	lecteur1=p0->lecteur1;
	lecteur2=p0->lecteur2;
	peercast=p0->peercast;
	peercast_exe=p0->peercast_exe;
	vlc_exe=p0->vlc_exe;
	freeboxtv=p0->freeboxtv;
	startlist=p0->startlist;
	mp_ontop=p0->mp_ontop;
	vlc_ontop=p0->vlc_ontop;
	skin_name=p0->skin_name;
	vlc_aspect=p0->vlc_aspect;
	mp_framedrop=p0->mp_framedrop;
	output=p0->output;
	mp_width=p0->mp_width;
	mp_height=p0->mp_height;
	 vlc_width=p0->vlc_width;
	 vlc_height=p0->vlc_height;
	 rec_dir=p0->rec_dir;
	 cap_dir=p0->cap_dir;
	mychannel_name=p0->mychannel_name;
	mychannel_genre=p0->mychannel_genre;
	mychannel_bitrate=p0->mychannel_bitrate;
	mp_cache=p0->mp_cache;
	timeshift=p0->timeshift;
	tv9tel=p0->tv9tel;
	}
	
	bool ReadPrefs();
	bool WritePrefs();
	wxString mplayer;
	wxString lecteur1;
	wxString lecteur2;
	int peercast;
	wxString peercast_exe;
	wxString vlc_exe;
	int freeboxtv;
	wxString startlist;
	int mp_ontop;
	int vlc_ontop;
	wxString skin_name;
	wxString vlc_aspect;
	int mp_framedrop;
	wxString output;
	wxString mp_width;
	wxString vlc_height;
	wxString vlc_width;
	wxString mp_height;
	wxString rec_dir;
	wxString cap_dir;
	wxString mychannel_name;
	wxString mychannel_genre;
	wxString mychannel_bitrate;
	wxString mp_cache;
	wxString timeshift;
	int tv9tel;
private:

};



class MyFrame: public wxFrame
{
public:
    MyFrame(const wxString& title);

    void OnRightUp (wxMouseEvent & event); 
    //MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);

    ~MyFrame ();
bool Maj();
wxString GetRealUrl(wxString url);

	bool ReadFavs();
	bool WriteFavs();
	bool ReadRecs();
	bool WriteRecs();
    wxSizer *CBox;
void OnTerm(wxProcessEvent& event);
void DoSize();
void OnPaint( wxPaintEvent &event );
void OnSearch( wxCommandEvent &WXUNUSED(event) );
bool AddFav(long indice);
bool DelFav(long indice);
virtual void OnSize(wxSizeEvent& event);
void OnPlay (wxCommandEvent & event);
void OnPlayStop (wxCommandEvent & event);
void OnEnregistrer (wxCommandEvent & event);
void OnStopEnregistrer (wxCommandEvent & event);
void Sound(wxCommandEvent& event);
void SetSound(int vol);
void OnMute(wxCommandEvent& event);
void OnIconize(wxCommandEvent& event);
    void OnClose (wxCloseEvent& event);
    void OnChoice( wxCommandEvent &event );
    void OnFichiersOuvrir (wxCommandEvent & event);
    void OnFichiersQuitter (wxCommandEvent & event);
    void PlayUrl(bool stop = false);
    wxImageList *m_imageListNormal;
    wxImageList *m_imageListSmall;

    wxPanel *m_panel;
    wxString url;
    int lecteur;
    MyListCtrl *m_listCtrl;
    wxTextCtrl *m_logWindow;
    wxToolBar * PeertvTBarUp,* PeertvTBarDown;

       // the PID of the last process we launched asynchronously
    long m_pidLast;
wxListBox *m_lbox;
bool IsFavOn;
Preferences *preferences;
Preferences *preferences_trans;

// the idle event wake up timer
    wxTimer m_timerIdleWakeUp;
wxString m_cmdLast;
long pid_peercast,pid_rec;
wxArrayString    *  chaines,*genres,*countrys,*bitrates,*nows,*formats,*ids;
long max_id_old; //+ old des nouveauts
wxTextCtrl *text_info;
wxSortedArrayString    *  favoris,*records; 
bool VolMute,Iconize;
wxString rec_name;
private:
int pTVvol;
wxProcess *process;
wxTextCtrl *search;
wxFrame  progress;
wxString pref_lecteur;

    // recreate the list control with the new flags
void RecreateList(wxFrame *frame,long flags, bool withText = true);
void InitWithReportItems(); 
   
    void OnOutilsFavoris (wxCommandEvent & event);
    void OnOutilsPr___4f___4rences (wxCommandEvent & event);
    void OnOutilsEPG (wxCommandEvent & event);
    void OnOutilsEnregistrements (wxCommandEvent & event);
    void OnMiseListes (wxCommandEvent & event);
    void OnHelpContents (wxCommandEvent & event);
    void OnHelpIndex (wxCommandEvent & event);
    void OnHelpAbout (wxCommandEvent & event);
wxString v_langue,v_genre;
long v_type;
wxBitmap  skin_image;
 wxChoice *s_langue,*s_genre,*s_type;

DECLARE_EVENT_TABLE()
};
const char * version="0.4.0.1 ";
const int NUM_NEWS = 20; //combien de chaines sont dites  nouvelles
const int ID_GEN = 10003;
const int ID_FILTRES = 10004;
const int ID_MPLAYER = 10005;
const int ID_VLC = 10006;
const int ID_TEXT = 10007;
const int ID_TEXTCTRL = 10008;
const int ID_FDROP = 10009;
const int ID_ONTOP = 10010;
const int ID_RENDU = 10011;
const int ID_APPLI = 10012;
const int ID_SKIN = 10013;
const int ID_PEERCAST = 10014;
const int ID_FREE = 10015;
const int ID_9TEL = 10016;
const int ID_WIDTH = 10017;
const int ID_HEIGHT = 10018;
const int ID_EXEC_MPLAYER = 10020;
const int ID_EXEC_PEERCAST = 10021;
const int ID_LINE = 10022;
const int ID_LEC1 = 10023;
const int ID_LEC2 = 10024;
const int ID_EXEC_VLC = 10025;
const int ID_VLC_ONTOP = 10026;
const int ID_VLC_WIDTH = 10027;
const int ID_VLC_HEIGHT = 10028;
const int ID_VLC_RATIO = 10029;
const int ID_SEARCH = 10030;
const int ID_REC = 10031;
const int ID_REC_DIR = 10032;
const int ID_FAV = 10030;
const int ID_MAJ = 10031;
const int ID_GUIDE = 10032;
const int ID_PREFS = 10033;
const int ID_GESTREC = 10034;
const int ID_PLAY = 10035;
const int ID_LREC = 10036;
const int ID_STOP = 10037;
const int ID_SPK = 10038;
const int ID_CAP = 10039;
const int ID_PLAYSTOP = 10040;
const int ID_MUTE = 10041;
const int ID_TOOL = 10042;
const int ID_CAP_DIR = 10043;
const int ID_ADV = 10044;
const int ID_MIN = 10045;
const int ID_MAX = 10046;
const int ID_REC_TIME = 10047;
const int VOL1 = 10140;
const int VOL2 = VOL1+1;
const int VOL3 = VOL1+2;
const int VOL4 = VOL1+3;
const int VOL5 = VOL1+4;
const int VOL6 = VOL1+5;
const int VOL7 = VOL1+6;
const int VOL8 = VOL1+7;
const int VOL9 = VOL1+8;
const int VOL10 = VOL1+9;
wxBitmap Pics( size_t index );

class MyPreferences : public wxDialog
{
public:
    MyPreferences(wxWindow *parent,int aig);
    void OnButton(wxCommandEvent& event);
private:
void OnChoice( wxCommandEvent &event );
void OnCheck( wxCommandEvent &event );
void OnText( wxCommandEvent &event );
wxTextCtrl *rec_dir;
wxTextCtrl *cap_dir;
wxTextCtrl *exec_mplayer;
wxTextCtrl *exec_vlc;
wxChoice *lecteur1;
wxChoice *lecteur2;
wxChoice *output;
wxChoice *vlc_aspect;
wxTextCtrl *vlc_width;
wxTextCtrl *vlc_height;
wxCheckBox *vlc_ontop;
wxTextCtrl *mp_width;
wxTextCtrl *mp_height;
wxCheckBox *mp_framedrop;
wxCheckBox *mp_ontop;
wxCheckBox *peercast;
wxCheckBox *freeboxtv;
wxCheckBox *tv9tel;
  wxSizer *sizer_general( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );
wxSizer *sizer_mplayer( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );
wxSizer *sizer_vlc( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *sizer_filtres( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );
wxSizer *sizer_rec( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

    wxPanel *m_panel;
  DECLARE_EVENT_TABLE()
};
const int ID_URL = 10021;

class OuvrirUrl : public wxDialog
{
public:
    OuvrirUrl(wxWindow *parent );
private:
wxSizer *SizOuvrirUrl( wxWindow *parent );
wxTextCtrl *ouvrurl;
void OnButton( wxCommandEvent &event );
  DECLARE_EVENT_TABLE()
};
class EPGDialog : public wxDialog
{
public:
    EPGDialog(wxWindow *parent );
private:
wxSizer *SizEPGDialog( wxWindow *parent );
MyListCtrl *epg;
void OnButton( wxCommandEvent &event );
  DECLARE_EVENT_TABLE()
};

class ListRecDialog : public wxDialog
{
public:
    ListRecDialog(wxWindow *parent );
private:
wxSizer *SizListRecDialog( wxWindow *parent );
RecCtrl *recs;
void OnButton( wxCommandEvent &event );
  DECLARE_EVENT_TABLE()
};


class RECDialog : public wxDialog
{
public:
    RECDialog(wxWindow *parent );
wxString recname,rectime;
wxTextCtrl *rec_dir,*rec_time;
private:
//bool OpAdv;    
wxSizer *SizRECDialog( wxWindow *parent );
void OnButton( wxCommandEvent &event );
void OnCheck( wxCommandEvent &event );
void OnText( wxCommandEvent &event );
  DECLARE_EVENT_TABLE()
};




class AboutDialog : public wxDialog
{
public:
    AboutDialog(wxWindow *parent );
private:
wxSizer *SizAboutDialog( wxWindow *parent );
void OnButton( wxCommandEvent &event );
  DECLARE_EVENT_TABLE()
};

void PeertvBarUp( wxToolBar *parent );
void PeertvBarDown( wxToolBar *parent ,bool mute,bool iconize);
#endif
